# Copyright 2018 Google Inc.
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# ----------------------------------------------------------------------------
#
#     ***     AUTO GENERATED CODE    ***    AUTO GENERATED CODE     ***
#
# ----------------------------------------------------------------------------
#
#     This file is automatically generated by Magic Modules and manual
#     changes will be clobbered when the file is regenerated.
#
#     Please read more about how to change this file in README.md and
#     CONTRIBUTING.md located at the root of this package.
#
# ----------------------------------------------------------------------------

module Google
  module Pubsub
    module Data
      # A class to manage data for PushConfig for subscription.
      class SubscriptionPushConfig
        include Comparable

        attr_reader :push_endpoint

        def to_json(_arg = nil)
          {
            'pushEndpoint' => push_endpoint
          }.reject { |_k, v| v.nil? }.to_json
        end

        def to_s
          {
            push_endpoint: push_endpoint.to_s
          }.map { |k, v| "#{k}: #{v}" }.join(', ')
        end

        def ==(other)
          return false unless other.is_a? SubscriptionPushConfig
          compare_fields(other).each do |compare|
            next if compare[:self].nil? || compare[:other].nil?
            return false if compare[:self] != compare[:other]
          end
          true
        end

        def <=>(other)
          return false unless other.is_a? SubscriptionPushConfig
          compare_fields(other).each do |compare|
            next if compare[:self].nil? || compare[:other].nil?
            result = compare[:self] <=> compare[:other]
            return result unless result.zero?
          end
          0
        end

        def inspect
          to_json
        end

        private

        def compare_fields(other)
          [
            { self: push_endpoint, other: other.push_endpoint }
          ]
        end
      end

      # Manages a SubscriptionPushConfig nested object
      # Data is coming from the GCP API
      class SubscriptionPushConfigApi < SubscriptionPushConfig
        def initialize(args)
          @push_endpoint = Google::Pubsub::Property::String.api_parse(args['pushEndpoint'])
        end
      end

      # Manages a SubscriptionPushConfig nested object
      # Data is coming from the Chef catalog
      class SubscriptionPushConfigCatalog < SubscriptionPushConfig
        def initialize(args)
          @push_endpoint = Google::Pubsub::Property::String.catalog_parse(args[:push_endpoint])
        end
      end
    end

    module Property
      # A class to manage input to PushConfig for subscription.
      class SubscriptionPushConfig
        def self.coerce
          ->(x) { ::Google::Pubsub::Property::SubscriptionPushConfig.catalog_parse(x) }
        end

        # Used for parsing Chef catalog
        def self.catalog_parse(value)
          return if value.nil?
          return value if value.is_a? Data::SubscriptionPushConfig
          Data::SubscriptionPushConfigCatalog.new(value)
        end

        # Used for parsing GCP API responses
        def self.api_parse(value)
          return if value.nil?
          return value if value.is_a? Data::SubscriptionPushConfig
          Data::SubscriptionPushConfigApi.new(value)
        end
      end
    end
  end
end
